-- Nested Transcation - Myth Or Reality?
BEGIN Tran OuterTran
Update tblEmployee set firstname = 'Ahmad' Where Empid=1
GO
BEGIN Tran InnerTran
GO
Update tblEmployee set lastname = 'Osama' where Empid=1

-- Committing Inner(nested) Transaction
COMMIT Tran InnerTran

-- Rollback Inner Transaction
ROLLBACK Tran OuterTran

-- rollback nester transaction
ROLLBACK Tran 

-- Committing OuterTran
SELECT [TranCount]=@@TRANCOUNT, Firstname,LastName 
FROM tblEmployee Where Empid=1

-- What about T-Log? Does it get clears when Inner(Nested) Tran is committed.
-- Check the log size
dbcc sqlperf(logspace)

BEGIN TRAN OuterTran
GO
BEGIN TRAN InnerTran
GO
IF OBJECT_ID('tbltesttran') IS NOT NULL
BEGIN
DROP TABLE tbltesttran
END
GO
SELECT [Sno]=Identity(int,1,1), [Col1]=(a.Object_ID * RAND())
Into tblTestTran
FROM sys.objects a cross join sys.objects b cross join sys.objects c

-- Commit inner tran and check log usage
Commit Tran InnerTran
GO
Checkpoint
-- Check the log size after transacations
dbcc sqlperf(logspace)
GO
-- committ outer tran and check log usage
Commit Tran OuterTran
GO
Checkpoint
GO
dbcc sqlperf(logspace)
GO

